/* mni1d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    real teta, tet, e;
    integer nf, ng, m1, nu;
} mni3_;

#define mni3_1 mni3_

struct {
    real ex, eg, egr, e2;
    doublereal step, mg, mp;
    integer iu, iws, ie, kit;
    doublereal gamma;
    integer n1, iwd;
} mni4_;

#define mni4_1 mni4_

/* Subroutine */ int mni1d_c(integer *n, doublereal *x, real *a, real *b,
        integer *m, integer *l, doublereal *f, real *fun, doublereal *g,
        real *grad, real *up, integer *i0, doublereal *rm, integer *iw,
        S_fp mni)
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    extern /* Subroutine */ int mni11_c(real *, real *, integer *, integer *,
            integer *, real *, real *, doublereal *, doublereal *,
            doublereal *, doublereal *, doublereal *, integer *, doublereal *,
            doublereal *, doublereal *, doublereal *, S_fp),
            mni21_c(real *, integer *, integer *, integer *, doublereal *,
            doublereal *, doublereal *, doublereal *),
            mni31_c(integer *, integer *, integer *, integer *, doublereal *,
            doublereal *, doublereal *),
            mni26_c(real *, integer *, integer *, integer *, doublereal *,
            doublereal *, doublereal *, integer *, doublereal *);
    static integer kmax, i__;
    static real t;
    extern /* Subroutine */ int mnrdn_c(doublereal *, integer *, doublereal *),
             mnrds_c(doublereal *, doublereal *, integer *, doublereal *);
    static real e1;
    static integer k1, k2, k3, k4, k5;
    static doublereal r1, r2, r3, r4;
    static integer k6, k7, ni;
    static doublereal fs;
    static integer kp;
    static doublereal fx, fz;
    static integer np;
    static doublereal mg1, mp1;

    /* Parameter adjustments */
    --g;
    --b;
    --a;
    --x;
    --f;
    --up;
    --i0;
    --rm;

    /* Function Body */
    mni3_1.nu = up[15];
    fz = 1e36;
    if (*l > 1) {
        goto L1;
    }
    mni4_1.iws = 134;
    mni4_1.eg = up[8];
    mni4_1.ex = up[7];
    goto L2;
L1:
    mni3_1.e = up[2];
    mni4_1.egr = up[11];
    mni4_1.ex = up[12];
    mni4_1.eg = up[13];
    mni4_1.iwd = 1;
    mni4_1.iws = 1;
    mni3_1.teta = up[1];
    mni3_1.tet = mni3_1.teta - 1.f;
    mni4_1.e2 = 10.f;
L2:
    ni = 0;
    mni3_1.nf = 0;
    mni3_1.ng = 0;
    *iw = 0;
    mni4_1.iu = up[4];
    mni4_1.kit = up[5];
    kmax = up[14];
    np = up[9];
    kp = up[10];
    mni4_1.step = 1.;
    k1 = (*n << 1) + 1;
/* Computing 2nd power */
    i__1 = *n;
    k2 = i__1 * i__1 + (*n << 1) + 1;
/* Computing 2nd power */
    i__1 = *n;
    k3 = (i__1 * i__1 << 1) + (*n << 1) + 1;
    k4 = k3 + *n * 5 - 1;
    k5 = k3 + *n * 6 - 1;
    k6 = k3 + *n * 7;
    k7 = k3 + *n - 1;
    mni4_1.n1 = *n - 1;
    mni3_1.m1 = *m + 1;
    mni4_1.gamma = 1e-20;
    mni21_c(fun, n, m, l, &x[1], &fx, &f[1], &fs);
L4:
    mni26_c(grad, n, m, l, &x[1], &f[1], &g[1], &i0[1], &rm[k4 + 1]);
L5:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L10: */
        g[i__] = rm[k4 + i__] + mni3_1.e * rm[k5 + i__];
    }
    mnrdn_c(&g[1], n, &mni4_1.mg);
    fx = f[1] + mni3_1.e * fs;
/* L15: */
    mni4_1.ie = 0;
L16:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        if (x[i__] < a[i__] + mni4_1.ex && g[i__] > 0.) {
            g[i__] = 0.;
        }
        if (x[i__] > b[i__] - mni4_1.ex && g[i__] < 0.) {
            g[i__] = 0.;
        }
/* L18: */
    }
    mnrdn_c(&g[1], n, &mni4_1.mp);
    if (np != 0 || kp == 0 || ni != 0) {
        goto L20;
    }
    mni31_c(n, m, l, &ni, &x[1], &fx, &f[1]);
L20:
    if (mni4_1.mp <= mni4_1.gamma) {
        goto L77;
    }
L21:
    if (ni >= kmax) {
        goto L85;
    }
    mni4_1.iwd = mni4_1.iws;
    ++ni;
    mni11_c(fun, grad, n, m, l, &a[1], &b[1], &x[1], &fx, &f[1], &fs, &g[1],
            &i0[1], &rm[k1], &rm[k2], &rm[k3], &rm[k6], (S_fp)mni);
    if (ni < np || kp == 0 || (ni - np) % kp != 0) {
        goto L22;
    }
    mni31_c(n, m, l, &ni, &x[1], &fx, &f[1]);
L22:
    if (mni4_1.iws == 9) {
        goto L90;
    }
    if (*l > 1 || mni4_1.iws != 4) {
        goto L35;
    }
    mni4_1.iws = 134;
    goto L21;
L35:
    if (mni4_1.iws == 13) {
        goto L70;
    }
    if (mni4_1.iws == 5) {
        goto L77;
    }
    if (mni4_1.iws == 4) {
        goto L45;
    }
    if (fs <= mni4_1.egr) {
        goto L37;
    }
L36:
    if (mni4_1.kit == 1) {
        mni4_1.ex = mni4_1.step * .1f;
    }
    mni3_1.e *= up[3];
    goto L5;
L37:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L38: */
        rm[i__] = x[i__];
    }
L40:
    fz = fx;
    mni4_1.kit = up[5];
    mni4_1.iws = 134;
    goto L21;
L45:
    if (fz >= fx) {
        goto L50;
    }
/* Computing MAX */
    r__1 = mni4_1.e2 / 2.f;
    mni4_1.e2 = max(r__1,1.f);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        x[i__] = rm[i__];
/* L46: */
        g[i__] = rm[*n + i__];
    }
    fx = fz;
    mni4_1.mg = mg1;
    mni4_1.mp = mp1;
    mni4_1.iws = 134;
    goto L21;
L50:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        rm[k7 + i__] = rm[k4 + i__];
        rm[*n + i__] = x[i__] - rm[i__];
        if (x[i__] > a[i__] + mni4_1.ex) {
            goto L51;
        }
        if (rm[k4 + i__] > 0.) {
            rm[k7 + i__] = 0.;
        }
        if (x[i__] < rm[i__]) {
            rm[*n + i__] = 0.f;
        }
L51:
        if (x[i__] < b[i__] - mni4_1.ex) {
            goto L52;
        }
        if (rm[k4 + i__] < 0.) {
            rm[k7 + i__] = 0.;
        }
        if (x[i__] > rm[i__]) {
            rm[*n + i__] = 0.f;
        }
L52:
        ;
    }
    mnrdn_c(&rm[*n + 1], n, &r1);
    mnrdn_c(&rm[k7 + 1], n, &r2);
    t = 0.f;
    if (r2 <= mni4_1.gamma) {
        goto L37;
    }
L54:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L55: */
        rm[i__] = rm[*n + i__] * (1 - t) / r1 - t * rm[k7 + i__] / r2;
    }
    mnrdn_c(&rm[1], n, &r4);
    if (r4 <= mni4_1.gamma) {
        goto L57;
    }
    mnrds_c(&rm[k7 + 1], &rm[1], n, &r3);
    r3 /= r4;
    if (r3 + mni4_1.gamma < 0.) {
        goto L60;
    }
L57:
    t += .1f;
    goto L54;
L60:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        rm[k7 + i__] = rm[i__] / r4;
        rm[*n + i__] = g[i__];
/* L65: */
        rm[i__] = x[i__];
    }
    fz = fx;
    mp1 = mni4_1.mp;
    mg1 = mni4_1.mg;
    fx = f[1];
    mni4_1.iws = 4;
    e1 = mni3_1.e;
    mni3_1.e = 0.f;
    if (mni4_1.egr > mni4_1.step) {
        mni4_1.step = mni4_1.egr;
    }
    (*mni)(fun, &a[1], &b[1], n, m, l, &rm[1], &fx, &f[1], &fs, &x[1],
            &rm[k7 + 1], &r3, &rm[k6]);
    mni3_1.e = e1;
    mni4_1.kit = up[5];
    mni4_1.iws = 134;
    goto L4;
L70:
    if (fs <= up[6] && mni4_1.step <= up[7]) {
        goto L76;
    }
    if (fs <= up[6]) {
        goto L75;
    }
L73:
    mni4_1.iws = 1;
    mni3_1.e *= up[3];
    mni4_1.e2 = 10.f;
    mni4_1.egr = fs * .1f;
    if (mni4_1.egr > .1f) {
        mni4_1.egr = .1f;
    }
    goto L5;
L75:
    mni4_1.iws = 134;
    mni4_1.kit = up[5];
    mni4_1.ex = mni4_1.step * .1f;
    if (mni4_1.ex < up[7]) {
        mni4_1.ex = up[7];
    }
    goto L16;
L76:
    if (mni4_1.mp <= up[8]) {
        goto L80;
    }
    mni4_1.eg = mni4_1.mp * .1f;
    if (mni4_1.eg < up[8]) {
        mni4_1.eg = up[8];
    }
    goto L40;
L77:
    if (fs > up[6]) {
        goto L78;
    }
    goto L80;
L78:
    if (mni4_1.iwd == 134) {
        goto L73;
    }
    mni4_1.iws = 1;
    goto L36;
L80:
    *iw = 1;
    goto L90;
L85:
    *iw = 4;
L90:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L95: */
        g[i__] = rm[k4 + i__];
    }
    if (kp == 0 || ni >= np && (ni - np) % kp == 0) {
        goto L100;
    }
    mni31_c(n, m, l, &ni, &x[1], &fx, &f[1]);
L100:
    rm[1] = (doublereal) ni;
    rm[2] = (doublereal) mni3_1.nf;
    rm[3] = (doublereal) mni3_1.ng;
    return 0;
} /* mni1d_c */
